// This is a personal academic project. Dear PVS-Studio, please check it.
// PVS-Studio Static Code Analyzer for C, C++ and C#: http://www.viva64.com
#include "../include/math.h"

static uint32_t m_z = 362436069;
static uint32_t m_w = 521288629;

uint32_t getUint() {
  m_z = 36969 * (m_z & 65535) + (m_z >> 16);
  m_w = 18000 * (m_w & 65535) + (m_w >> 16);
  return (m_z << 16) + m_w;
}

double getUniform(uint32_t max) {
  uint32_t u = getUint();
  return (u + 1.0) * 2.328306435454494e-10 * max;
}

void boxMuller(double * normal) {
    double random1 = getUniform(1);
    double random2 = getUniform(1);
    *normal = sqrt(-2 * log(random1)) * cos(2 * M_PI * random2);
}